; Music Driver IWADRV (C)TENKY CO.LTD p
; C[` (for NASM)

%include 'hoot.inc'

		ORG	0x0100
		USE16
		CPU	186

start:		cli
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	sp,stack
		mov	bx,0x05		; Ff[^o^
		call	voiceset

		mov	ax,0x257f	; hoothCoo^
		mov	dx,vect_7f
		int	0x21

		sti
mainloop:	hlt
		hlt
		hlt
		hlt
		hlt
		jmp	short mainloop

; hootR[
; inp8(HOOTPORT) = 0  PC98DOS::Play
; inp8(HOOTPORT) = 2  PC98DOS::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

vect_7f:	pusha
		push	ds
		push	es
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	short .play
		cmp	al,HP_STOP
		jz	short .fadeout
.ed:		pop	es
		pop	ds
		popa
		iret

.play:		call	stop_music	; t~
		mov	ah,0x3f		; [DOS] read hundle
		mov	dx,HOOTPORT+4	; Ff[^ԍwǂݍ
		in	al,dx
		or	al,al
		jz	.musload	; w肳ĂȂΉF[hXLbv

.voiceload:	push	ax
		mov	ax,0x0aff	; ̉Ff[^Sč폜
		int	0xeb
		pop	ax
		mov	bl,al		; hundlewƂ
		xor	bh,bh
		mov	dx,buff
		mov	cx,0x8000	; Ff[^őTCY(K)
		int	0x21		; Ff[^[h
		jc	.stop
		call	rewind		; t@C|C^߂
		jc	.stop
		mov	cx,cs
		mov	dx,buff		; Ff[^Ao^(CX:DX)
		mov	ah,0x09
		int	0xeb

.musload:
		mov	ax,0x06ff	; o^ς݋ȃf[^Sč폜
		int	0xeb
		mov	ah,0x3f		; [DOS] read hundle
		xor	bx,bx		; W
		mov	cx,0x8000	; ȃf[^őTCY(K)
		mov	dx,buff
		int	0x21		; ȃf[^[h
		jc	.stop

		mov	cx,cs
		mov	dx,buff
		mov	ah,0x01		; ȃf[^o^(CX:DX)
		int	0xeb

		mov	dx,HOOTPORT+5	; BGM/SEʂǂݍ
		in	al,dx
		or	al,0x7f		; ~[g{[
		mov	dl,al
		mov	al,[buff+2]	; ID
		mov	ah,0x02		; tJn
		int	0xeb
		jnc	short .ed

.stop:		call	stop_music	; ُ펞͉t~Ė߂
		jmp	short .ed

.fadeout:	mov	ax,0308h	; tF[hAEg(AL=x)
		int	0xeb
		jmp	short .ed

stop_music:	mov	ax,0x03ff	; t~(1)
		int	0xeb
		mov	ax,0x0300	; t~(2)
		int	0xeb
		ret

; Fݒ BX=t@Cnh
voiceset:	mov	ah,0x3f		; [DOS] read hundle
		mov	cx,0x8000	; Ff[^őTCY(K)
		mov	dx,buff
		int	0x21		; Ff[^[h
		jc	return		; G[Ȃ疳
		push	bx
		mov	cx,cs
		mov	dx,buff
		mov	ah,0x09		; Ff[^Zbg(CX:DX)
		int	0xeb
		pop	bx

rewind:		push	ax		; t@C|C^(BX)擪ɖ߂
		push	cx
		push	dx
		mov	ax,0x4200	; [DOS] move file pointer
		xor	cx,cx
		mov	dx,cx
		int	0x21
		pop	dx
		pop	cx
		pop	ax
return:		ret

		times 0x100 db 0x00	; X^bNGA
stack:
		align	0x10
buff:					; ȉA[hobt@
		ends

